diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
index e0f5fe519..03893b515 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
@@ -134,7 +134,7 @@ public class Chunk
         averageBlockHeight = acc / (CHUNK_SIZE_X * CHUNK_SIZE_Z);
     }
 
-    public void recalcHeightmap()
+    public void recalcHeightmapAndLightmap()
     {
         recalcHeightmapOnly();
 
@@ -155,14 +155,15 @@ public class Chunk
                 }
             }
         }
+        isModified = true;
+    }
 
+    public void checkForLightGaps() {
         for(int x = 0; x < CHUNK_SIZE_X; x++) {
             for(int z = 0; z < CHUNK_SIZE_Z; z++) {
                 lightGaps(x, z);
             }
         }
-
-        isModified = true;
     }
 
     private void lightGaps(int x, int z) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
index 2ab5f7fb7..cdf186f65 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
@@ -21,22 +21,36 @@ public class ChunkCache
     private final @NotNull Chunk @NotNull [] @NotNull [] chunkArray;
     private final @NotNull World world;
 
-    public ChunkCache(final @NotNull World world, final @NotNull TilePos min, final @NotNull TilePos max) {
+    private final int widthX;
+    private final int widthZ;
+
+    public ChunkCache(final @NotNull World world, final @NotNull TilePos min, final @NotNull TilePos max, boolean priority) {
         this.world = world;
         this.origin = min.toChunkPos();
 
         final @NotNull ChunkPos chunkMax = max.toChunkPos();
-        this.chunkArray = new Chunk[(chunkMax.x - this.origin.x) + 1][(chunkMax.z - this.origin.z) + 1];
-        for (int x = this.origin.x; x <= chunkMax.x; x++) {
-            for (int z = this.origin.z; z <= chunkMax.z; z++) {
-                this.chunkArray[x - this.origin.x][z - this.origin.z] = this.world.getChunk(new ChunkPos(x, z));
+        this.widthX = (chunkMax.x - this.origin.x) + 1;
+        this.widthZ = (chunkMax.z - this.origin.z) + 1;
+        this.chunkArray = new Chunk[this.widthX][this.widthZ];
+        for (int x = 0; x < this.widthX; x++) {
+            for (int z = 0; z < this.widthZ; z++) {
+                this.chunkArray[x][z] = this.world.getChunk(new ChunkPos(x + this.origin.x, z + this.origin.z), priority);
             }
         }
     }
 
     @Deprecated
     public ChunkCache(final @NotNull World world, final int minX, final int minY, final int minZ, final int maxX, final int maxY, final int maxZ) {
-        this(world, new TilePos(minX, minY, minZ), new TilePos(maxX, maxY, maxZ));
+        this(world, new TilePos(minX, minY, minZ), new TilePos(maxX, maxY, maxZ), true);
+    }
+
+    public boolean allLoaded() {
+        for (int x = 0; x < this.widthX; x++) {
+            for (int z = 0; z < this.widthZ; z++) {
+                if (!this.world.isChunkLoaded(new ChunkPos(x + this.origin.x, z + this.origin.z))) return false;
+            }
+        }
+        return true;
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java
index 139b653f5..f716543c3 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java
@@ -265,7 +265,7 @@ public class ChunkLoaderLegacy
         if(chunk.heightMap == null)
         {
             chunk.heightMap = new short[Chunk.CHUNK_SIZE_X * Chunk.CHUNK_SIZE_Z];
-            chunk.recalcHeightmap();
+            chunk.recalcHeightmapAndLightmap();
         }
         if (chunk.temperature == null || chunk.temperature.length == 0)
         {
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderRegionAsync.java b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderRegionAsync.java
index 31f4b3456..a55c108ce 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderRegionAsync.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderRegionAsync.java
@@ -26,6 +26,7 @@ public class ChunkLoaderRegionAsync
     static
     {
         chunkSaveThread = new ChunkSaveThread();
+        chunkSaveThread.setName("Chunk Save Thread");
         chunkSaveThread.start();
         System.out.println("Spawned new chunk save thread!");
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/EmptyChunk.java b/game/core/src/main/java/net/minecraft/core/world/chunk/EmptyChunk.java
index 0d16c9da0..f235c6aab 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/EmptyChunk.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/EmptyChunk.java
@@ -35,7 +35,7 @@ public class EmptyChunk extends Chunk {
     public void recalcHeightmapOnly() { }
 
     @Override
-    public void recalcHeightmap() { }
+    public void recalcHeightmapAndLightmap() { }
 
     @Override
     public int getBlockId(final @NotNull ChunkTilePos tilePos) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/provider/ChunkProviderThreaded.java b/game/core/src/main/java/net/minecraft/core/world/chunk/provider/ChunkProviderThreaded.java
new file mode 100644
index 000000000..e76ccd3ce
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/provider/ChunkProviderThreaded.java
@@ -0,0 +1,438 @@
+package net.minecraft.core.world.chunk.provider;
+
+import com.mojang.logging.LogUtils;
+import it.unimi.dsi.fastutil.objects.Object2ObjectOpenHashMap;
+import it.unimi.dsi.fastutil.objects.ObjectArrayList;
+import it.unimi.dsi.fastutil.objects.ObjectOpenHashSet;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.world.ProgressListener;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.chunk.Chunk;
+import net.minecraft.core.world.chunk.IChunkLoader;
+import net.minecraft.core.world.generate.chunk.ChunkGenerator;
+import net.minecraft.core.world.pos.ChunkPos;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.slf4j.Logger;
+
+import java.io.IOException;
+import java.util.ArrayList;
+import java.util.Collection;
+import java.util.HashMap;
+import java.util.HashSet;
+import java.util.Iterator;
+import java.util.List;
+import java.util.Map;
+import java.util.Set;
+import java.util.concurrent.atomic.AtomicBoolean;
+
+public class ChunkProviderThreaded implements IChunkProvider {
+    protected static final Logger LOGGER = LogUtils.getLogger();
+    protected static final @NotNull ChunkPos MIN_POS = new ChunkPos(Integer.MIN_VALUE, Integer.MIN_VALUE);
+
+    protected final @NotNull Chunk empty;
+    protected final @NotNull World world;
+    protected final @NotNull IChunkLoader chunkLoader;
+    protected final @NotNull ChunkGenerator chunkGenerator;
+    protected final @NotNull ChunkGenThread genThread;
+
+    protected final @NotNull Map<@NotNull ChunkPos, @NotNull Chunk> loadedChunks = new Object2ObjectOpenHashMap<>();
+    protected final @NotNull Map<@NotNull ChunkPos, @NotNull Chunk> preparedUndecoratedChunks = new Object2ObjectOpenHashMap<>();
+    protected final @NotNull Set<@NotNull Chunk> positionsToCheckIfCanDecorate = new ObjectOpenHashSet<>();
+    protected final @NotNull Set<@NotNull Chunk> positionsToCheckIfCanDecorateCopy = new ObjectOpenHashSet<>();
+    protected @Nullable ChunkPos chunkOver;
+
+    protected @NotNull Chunk lastQueriedChunk;
+    protected @NotNull ChunkPos lastQueriedChunkPos = MIN_POS;
+
+    protected int tickCount = 0;
+
+    public ChunkProviderThreaded(@NotNull World world, @NotNull IChunkLoader chunkLoader, @NotNull ChunkGenerator chunkGenerator) {
+        this.world = world;
+        this.chunkLoader = chunkLoader;
+        this.chunkGenerator = chunkGenerator;
+        this.empty = new Chunk(world, new ChunkPos(0, 0));
+        this.lastQueriedChunk = this.empty;
+
+        this.genThread = new ChunkGenThread(this);
+        this.genThread.setName("Chunk Gen Thread");
+        this.genThread.setDaemon(true);
+        this.genThread.setPriority(Math.max(Thread.currentThread().getPriority() - 1, Thread.MIN_PRIORITY));
+        this.genThread.start();
+    }
+
+    @Override
+    public boolean isChunkLoaded(@NotNull ChunkPos chunkPos) {
+        if (chunkPos.equals(this.lastQueriedChunkPos)) return true;
+        synchronized (this.loadedChunks) {
+            return this.loadedChunks.containsKey(chunkPos);
+        }
+    }
+
+    @Override
+    public @NotNull Chunk provideChunk(@NotNull ChunkPos chunkPos, boolean priority) {
+        if (chunkPos.equals(this.lastQueriedChunkPos)) return this.lastQueriedChunk;
+
+        Chunk chunk;
+        synchronized (this.loadedChunks) {
+            chunk = this.loadedChunks.get(chunkPos);
+        }
+        if (chunk != null) {
+            this.lastQueriedChunkPos = chunkPos;
+            this.lastQueriedChunk = chunk;
+            if (!chunk.isTerrainPopulated) {
+                handleDecoration(chunk);
+            }
+            return chunk;
+        }
+        if (isChunkValid(chunkPos) || this.world.findingSpawnPoint) {
+            if (priority || this.world.findingSpawnPoint) {
+                Chunk c = loadChunk(chunkPos);
+                addChunk(c);
+                return c;
+            } else {
+                this.genThread.queueChunk(chunkPos);
+            }
+        }
+        return this.empty;
+    }
+
+    @Override
+    public @NotNull Chunk prepareChunk(@NotNull ChunkPos chunkPos, boolean priority) {
+        return provideChunk(chunkPos, priority);
+    }
+
+    @Override
+    public void regenerateChunk(@NotNull ChunkPos chunkPos) {
+        throw new UnsupportedOperationException();
+    }
+
+    @Override
+    public void populate(@NotNull ChunkPos chunkPos) {
+        Chunk chunk = provideChunk(chunkPos, true);
+        decorate(chunk);
+    }
+
+    public void decorate(@NotNull Chunk chunk) {
+        if (!chunk.isTerrainPopulated) {
+            chunk.isTerrainPopulated = true;
+            this.chunkGenerator.decorate(chunk);
+            chunk.setChunkModified();
+
+            if (this.world.getCurrentWeather() != null) {
+                this.world.getCurrentWeather().doChunkLoadEffect(this.world, chunk);
+            }
+        }
+    }
+
+    @Override
+    public void setCurrentChunkOver(@NotNull ChunkPos chunkPos) {
+        this.chunkOver = chunkPos;
+    }
+
+    @Override
+    public boolean saveChunks(boolean saveImmediately, @Nullable ProgressListener progressListener) {
+        Collection<Chunk> chunks;
+        synchronized (this.loadedChunks) {
+            chunks = this.loadedChunks.values();
+            int totalNeedSaving = 0;
+            for (Chunk chunk : chunks) {
+                if (chunk.needsSaving(saveImmediately)) {
+                    totalNeedSaving++;
+                }
+            }
+            int chunksSaved = 0;
+            for (Chunk chunk : chunks) {
+                if (chunk.needsSaving(saveImmediately)) {
+                    saveChunk(chunk);
+
+                    if (++chunksSaved > 6 && !saveImmediately) {
+                        return false;
+                    }
+
+                    if (progressListener != null && chunksSaved % 10 == 0) {
+                        progressListener.progressStagePercentage((chunksSaved * 100) / totalNeedSaving);
+                    }
+                }
+            }
+        }
+        return true;
+    }
+
+    @Override
+    public boolean tick() {
+        tickCount++;
+        synchronized (this.preparedUndecoratedChunks) {
+            if (!this.preparedUndecoratedChunks.isEmpty()) {
+                int count = 0;
+                for (Iterator<Chunk> iterator = this.preparedUndecoratedChunks.values().iterator(); iterator.hasNext(); ) {
+                    Chunk chunk = iterator.next();
+                    addChunk(chunk);
+                    iterator.remove();
+                    if (count++ > 4) {
+                        break;
+                    }
+                }
+            }
+        }
+        synchronized (this.positionsToCheckIfCanDecorate) {
+            synchronized (this.positionsToCheckIfCanDecorateCopy) {
+                this.positionsToCheckIfCanDecorateCopy.clear();
+                this.positionsToCheckIfCanDecorateCopy.addAll(this.positionsToCheckIfCanDecorate);
+                this.positionsToCheckIfCanDecorate.clear();
+            }
+        }
+        synchronized (this.positionsToCheckIfCanDecorateCopy) {
+            if (!this.positionsToCheckIfCanDecorateCopy.isEmpty()) {
+                for (Chunk chunk : this.positionsToCheckIfCanDecorateCopy) {
+                    handleDecoration(chunk);
+                }
+                this.positionsToCheckIfCanDecorateCopy.clear();
+            }
+        }
+
+        synchronized (this.loadedChunks) {
+            var itr = this.loadedChunks.entrySet().iterator();
+            while (itr.hasNext()) {
+                var entry = itr.next();
+                ChunkPos pos = entry.getKey();
+                Chunk chunk = entry.getValue();
+                if (!isChunkValid(pos)) {
+                    saveChunk(chunk);
+                    chunk.onUnload();
+                    itr.remove();
+                    if (this.lastQueriedChunkPos.equals(pos)) {
+                        this.lastQueriedChunkPos = MIN_POS;
+                        this.lastQueriedChunk = this.empty;
+                    }
+                }
+            }
+        }
+        return false;
+    }
+
+    private void addChunk(@NotNull Chunk chunk) {
+        synchronized (this.loadedChunks) {
+            if (this.loadedChunks.containsKey(chunk.pos)) {
+                return;
+            }
+            this.loadedChunks.put(chunk.pos, chunk);
+        }
+        chunk.checkForLightGaps();
+        chunk.lastSaveTime = this.world.getWorldTime();
+        chunk.onLoad();
+
+        if (!chunk.isTerrainPopulated) {
+            handleDecoration(chunk);
+        }
+        checkForNeighborDecorations(chunk.pos);
+    }
+
+    private boolean handleDecoration(@NotNull Chunk chunk) {
+        ChunkPos pos = chunk.pos;
+        if (!chunk.isTerrainPopulated && isChunkValid(pos)) {
+            synchronized (this.loadedChunks) {
+                ChunkPos northPos       = pos.add( 0, -1);
+                ChunkPos northEastPos   = pos.add( 1, -1);
+                ChunkPos eastPos        = pos.add( 1,  0);
+                ChunkPos southEastPos   = pos.add( 1,  1);
+                ChunkPos southPos       = pos.add( 0,  1);
+                ChunkPos southWestPos   = pos.add(-1,  1);
+                ChunkPos westPos        = pos.add(-1,  0);
+                ChunkPos northWestPos   = pos.add(-1, -1);
+                boolean northLoaded     = this.loadedChunks.containsKey(northPos);
+                boolean northEastLoaded = this.loadedChunks.containsKey(northEastPos);
+                boolean eastLoaded      = this.loadedChunks.containsKey(eastPos);
+                boolean southEastLoaded = this.loadedChunks.containsKey(southEastPos);
+                boolean southLoaded     = this.loadedChunks.containsKey(southPos);
+                boolean southWestLoaded = this.loadedChunks.containsKey(southWestPos);
+                boolean westLoaded      = this.loadedChunks.containsKey(westPos);
+                boolean northWestLoaded = this.loadedChunks.containsKey(northWestPos);
+                if (northLoaded && northEastLoaded && eastLoaded && southEastLoaded && southLoaded && southWestLoaded && westLoaded && northWestLoaded) {
+                    decorate(chunk);
+                    return true;
+                }
+            }
+        }
+        return false;
+    }
+
+    protected void checkForNeighborDecorations(@NotNull ChunkPos chunkPos) {
+        ChunkPos northPos       = chunkPos.add( 0, -1);
+        ChunkPos northEastPos   = chunkPos.add( 1, -1);
+        ChunkPos eastPos        = chunkPos.add( 1,  0);
+        ChunkPos southEastPos   = chunkPos.add( 1,  1);
+        ChunkPos southPos       = chunkPos.add( 0,  1);
+        ChunkPos southWestPos   = chunkPos.add(-1,  1);
+        ChunkPos westPos        = chunkPos.add(-1,  0);
+        ChunkPos northWestPos   = chunkPos.add(-1, -1);
+        synchronized (this.positionsToCheckIfCanDecorate) {
+            Chunk c;
+            c = this.loadedChunks.get(northPos);
+            if (c != null && !c.isTerrainPopulated) this.positionsToCheckIfCanDecorate.add(c);
+            c = this.loadedChunks.get(northEastPos);
+            if (c != null && !c.isTerrainPopulated) this.positionsToCheckIfCanDecorate.add(c);
+            c = this.loadedChunks.get(eastPos);
+            if (c != null && !c.isTerrainPopulated) this.positionsToCheckIfCanDecorate.add(c);
+            c = this.loadedChunks.get(southEastPos);
+            if (c != null && !c.isTerrainPopulated) this.positionsToCheckIfCanDecorate.add(c);
+            c = this.loadedChunks.get(southPos);
+            if (c != null && !c.isTerrainPopulated) this.positionsToCheckIfCanDecorate.add(c);
+            c = this.loadedChunks.get(southWestPos);
+            if (c != null && !c.isTerrainPopulated) this.positionsToCheckIfCanDecorate.add(c);
+            c = this.loadedChunks.get(westPos);
+            if (c != null && !c.isTerrainPopulated) this.positionsToCheckIfCanDecorate.add(c);
+            c = this.loadedChunks.get(northWestPos);
+            if (c != null && !c.isTerrainPopulated) this.positionsToCheckIfCanDecorate.add(c);
+        }
+    }
+
+    @Override
+    public boolean canSave() {
+        return true;
+    }
+
+    protected boolean isChunkValid(@NotNull ChunkPos chunkPos) {
+        int rd = this.world.renderDistance() + 1;
+        if (this.chunkOver != null) {
+            int dx = this.chunkOver.x - chunkPos.x;
+            int dz = this.chunkOver.z - chunkPos.z;
+            if (dx <= 2 && dx >= -2 && dz <= 2 && dz >= -2) {
+                return true;
+            }
+        }
+        synchronized (this.world.players) {
+            @NotNull List<@NotNull Player> players = this.world.players;
+            int size = players.size();
+            for (int i = 0; i < size; i++) {
+                Player player = players.get(i);
+                int pCX = ((int) player.x >> 4);
+                int pCZ = ((int) player.z >> 4);
+                int dx = pCX - chunkPos.x;
+                int dz = pCZ - chunkPos.z;
+                if (dx <= rd && dx >= -rd && dz <= rd && dz >= -rd) {
+                    return true;
+                }
+            }
+        }
+        return false;
+    }
+
+    private @NotNull Chunk loadChunk(@NotNull ChunkPos chunkPos) {
+        try {
+            Chunk chunk = this.chunkLoader.loadChunk(this.world, chunkPos.x, chunkPos.z);
+            if (chunk == null) {
+                chunk = this.chunkGenerator.generate(chunkPos.x, chunkPos.z);
+                chunk.fixMissingBlocks();
+            }
+            return chunk;
+        } catch (Exception exception) {
+            LOGGER.error("Error loading chunk at X:{}, Z:{}", chunkPos.x, chunkPos.z, exception);
+        }
+        return this.empty;
+    }
+
+    private void saveChunk(@NotNull Chunk chunk) {
+        try {
+            chunk.lastSaveTime = this.world.getWorldTime();
+            this.chunkLoader.saveChunk(this.world, chunk);
+            chunk.isModified = false;
+        } catch (IOException e) {
+            LOGGER.error("Error saving chunk at X:{}, Z:{}", chunk.pos.x, chunk.pos.x, e);
+        }
+    }
+
+    @Override
+    public @NotNull String getInfoString() {
+        return String.format("Loaded: %s, Queued: %s, Undecorated: %s", this.loadedChunks.size(), this.preparedUndecoratedChunks.size(), this.positionsToCheckIfCanDecorate.size());
+    }
+
+    @Override
+    public void unloadAllChunks() {
+        synchronized (this.loadedChunks) {
+            for (Chunk chunk : this.loadedChunks.values()) {
+                chunk.onUnload();
+            }
+            this.loadedChunks.clear();
+        }
+        synchronized (this.preparedUndecoratedChunks) {
+            this.preparedUndecoratedChunks.clear();
+        }
+        System.gc();
+    }
+
+    @Override
+    public void close() {
+        this.genThread.close();
+    }
+
+    public static class ChunkGenThread extends Thread {
+        private boolean running = true;
+        private final AtomicBoolean sleeping = new AtomicBoolean(false);
+
+        private final @NotNull ArrayList<ChunkPos> chunkQueueSet = new ArrayList<>();
+        private final @NotNull ChunkProviderThreaded chunkProvider;
+
+        public ChunkGenThread(@NotNull ChunkProviderThreaded chunkProvider) {
+            this.chunkProvider = chunkProvider;
+        }
+
+        @Override
+        public void run() {
+            while (this.running) {
+                try {
+                    this.sleeping.set(false);
+                    boolean hasWork;
+                    synchronized (this.chunkQueueSet) {
+                        hasWork = !this.chunkQueueSet.isEmpty();
+                    }
+                    if (!hasWork) {
+                        try {
+                            this.sleeping.set(true);
+                            Thread.sleep(Integer.MAX_VALUE);
+                            continue;
+                        } catch (InterruptedException ignored) {
+                        }
+                    }
+                    ChunkPos first = null;
+                    synchronized (this.chunkQueueSet) {
+                        this.chunkQueueSet.removeIf(this.chunkProvider::isChunkLoaded);
+                        if (!this.chunkQueueSet.isEmpty()) {
+                            first = this.chunkQueueSet.remove(0);
+                        }
+                    }
+                    if (first == null) continue;
+                    Chunk chunk = this.chunkProvider.loadChunk(first);
+                    synchronized (this.chunkProvider.preparedUndecoratedChunks) {
+                        this.chunkProvider.preparedUndecoratedChunks.put(chunk.pos, chunk);
+                    }
+                } catch (Exception e) {
+                    LOGGER.error("Error in chunk gen thread!", e);
+                }
+            }
+        }
+
+        public void queueChunk(@NotNull ChunkPos chunkPos) {
+            synchronized (this.chunkProvider.preparedUndecoratedChunks) {
+                if (this.chunkProvider.preparedUndecoratedChunks.containsKey(chunkPos)) return;
+            }
+            synchronized (this.chunkQueueSet) {
+                if (!this.chunkQueueSet.contains(chunkPos)) {
+                    this.chunkQueueSet.add(chunkPos);
+                } else {
+                    return;
+                }
+            }
+            if (this.sleeping.get()) {
+                interrupt();
+            }
+        }
+
+        public void close() {
+            this.running = false;
+            if (this.sleeping.get()) {
+                interrupt();
+            }
+        }
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/provider/IChunkProvider.java b/game/core/src/main/java/net/minecraft/core/world/chunk/provider/IChunkProvider.java
index cc48170c7..5068c601c 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/provider/IChunkProvider.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/provider/IChunkProvider.java
@@ -2,29 +2,59 @@ package net.minecraft.core.world.chunk.provider;
 
 import net.minecraft.core.world.ProgressListener;
 import net.minecraft.core.world.chunk.Chunk;
-
-public interface IChunkProvider
-{
-
-    boolean isChunkLoaded(int chunkX, int chunkZ);
-
-    Chunk provideChunk(int chunkX, int chunkZ);
-
-    Chunk prepareChunk(int chunkX, int chunkZ);
-
-    void regenerateChunk(int chunkX, int chunkZ);
-
-    void populate(IChunkProvider chunkProvider, int chunkX, int chunkZ);
-
-    boolean saveChunks(boolean saveImmediately, ProgressListener progressUpdate);
+import net.minecraft.core.world.pos.ChunkPos;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public interface IChunkProvider {
+
+    @Deprecated
+    default boolean isChunkLoaded(int chunkX, int chunkZ) {
+        return isChunkLoaded(new ChunkPos(chunkX, chunkZ));
+    }
+    boolean isChunkLoaded(@NotNull ChunkPos chunkPos);
+
+    @Deprecated
+    default @NotNull Chunk provideChunk(int chunkX, int chunkZ) {
+        return provideChunk(new ChunkPos(chunkX, chunkZ), true);
+    }
+    @NotNull Chunk provideChunk(@NotNull ChunkPos chunkPos, boolean priority);
+
+    @Deprecated
+    default @NotNull Chunk prepareChunk(int chunkX, int chunkZ) {
+        return prepareChunk(new ChunkPos(chunkX, chunkZ), true);
+    }
+    @NotNull Chunk prepareChunk(@NotNull ChunkPos chunkPos, boolean priority);
+
+    @Deprecated
+    default void regenerateChunk(int chunkX, int chunkZ) {
+        regenerateChunk(new ChunkPos(chunkX, chunkZ));
+    }
+    void regenerateChunk(@NotNull ChunkPos chunkPos);
+
+    @Deprecated
+    default void populate(IChunkProvider chunkProvider, int chunkX, int chunkZ) {
+        populate(new ChunkPos(chunkX, chunkZ));
+    }
+    void populate(@NotNull ChunkPos chunkPos);
+
+    @Deprecated
+    default void setCurrentChunkOver(int chunkX, int chunkZ) {
+        setCurrentChunkOver(new ChunkPos(chunkX, chunkZ));
+    }
+    void setCurrentChunkOver(@NotNull ChunkPos chunkPos);
+
+    boolean saveChunks(boolean saveImmediately, @Nullable ProgressListener progressListener);
 
     boolean tick();
 
     boolean canSave();
 
-    String getInfoString();
-    
+    @NotNull String getInfoString();
     void unloadAllChunks();
 
-    void setCurrentChunkOver(int chunkX, int chunkZ);
+    default void close() {
+
+    }
+
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/data/ChunkNibbleArray.java b/game/core/src/main/java/net/minecraft/core/world/data/ChunkNibbleArray.java
index 3bf581205..0f9015968 100644
--- a/game/core/src/main/java/net/minecraft/core/world/data/ChunkNibbleArray.java
+++ b/game/core/src/main/java/net/minecraft/core/world/data/ChunkNibbleArray.java
@@ -1,14 +1,15 @@
 package net.minecraft.core.world.data;
 
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 /**
  * Models an array of nibbles that is accessible by X, Y and Z coordinates.
  */
 public class ChunkNibbleArray
-    implements ChunkArray<Integer>
+//    implements ChunkArray<Integer>
 {
-    public final byte[] data;
+    public final byte @Nullable [] data;
 
     private final int xSize, ySize, zSize;
 
@@ -17,7 +18,7 @@ public class ChunkNibbleArray
         this.xSize = xSize;
         this.ySize = ySize;
         this.zSize = zSize;
-        data = new byte[(xSize * ySize * zSize) >> 1];
+        this.data = new byte[(xSize * ySize * zSize) >> 1];
     }
 
     public ChunkNibbleArray(int xSize, int ySize, int zSize, byte[] data)
@@ -35,41 +36,41 @@ public class ChunkNibbleArray
         }
     }
 
-    @Override
-    public @NotNull Integer get(int x, int y, int z)
+//    @Override
+    public /*@NotNull Integer*/ int get(int x, int y, int z)
     {
-        int index = (y * zSize * xSize) + (z * xSize) + x;
+        int index = (y * this.zSize * this.xSize) + (z * this.xSize) + x;
         int nibbleIndex = index >> 1;
         int nibblePart = index & 0x01;
         if(nibblePart == 0)
         {
-            return data[nibbleIndex] & 0x0F;
+            return this.data[nibbleIndex] & 0x0F;
         }
         else
         {
-            return data[nibbleIndex] >> 4 & 0x0F;
+            return this.data[nibbleIndex] >> 4 & 0x0F;
         }
     }
 
-    @Override
-    public void set(int x, int y, int z, Integer value)
+//    @Override
+    public void set(int x, int y, int z, /*Integer*/ int value)
     {
-        int index = (y * zSize * xSize) + (z * xSize) + x;
+        int index = (y * this.zSize * this.xSize) + (z * this.xSize) + x;
         int nibbleIndex = index >> 1;
         int nibblePart = index & 0x01;
         if(nibblePart == 0)
         {
-            data[nibbleIndex] = (byte)((data[nibbleIndex] & 0xF0) | (value & 0x0F));
+            this.data[nibbleIndex] = (byte)((this.data[nibbleIndex] & 0xF0) | (value & 0x0F));
         }
         else
         {
-            data[nibbleIndex] = (byte)((data[nibbleIndex] & 0x0F) | ((value & 0x0F) << 4));
+            this.data[nibbleIndex] = (byte)((this.data[nibbleIndex] & 0x0F) | ((value & 0x0F) << 4));
         }
     }
 
-    @Override
+//    @Override
     public boolean isValid()
     {
-        return data != null && data.length == ((xSize * ySize * zSize) >> 1);
+        return this.data != null && this.data.length == ((this.xSize * this.ySize * this.zSize) >> 1);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/data/ChunkUnsignedByteArray.java b/game/core/src/main/java/net/minecraft/core/world/data/ChunkUnsignedByteArray.java
index 093a0b00c..54029e819 100644
--- a/game/core/src/main/java/net/minecraft/core/world/data/ChunkUnsignedByteArray.java
+++ b/game/core/src/main/java/net/minecraft/core/world/data/ChunkUnsignedByteArray.java
@@ -2,57 +2,49 @@ package net.minecraft.core.world.data;
 
 
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 /**
  * Models an array of unsigned bytes that is accessible by X, Y and Z coordinates.
  */
 public class ChunkUnsignedByteArray
-    implements ChunkArray<Integer>
-{
-    public final byte[] data;
+    /*implements ChunkArray<Integer>*/ {
+    public final byte @Nullable [] data;
 
     private final int xSize, ySize, zSize;
 
-    public ChunkUnsignedByteArray(int xSize, int ySize, int zSize)
-    {
+    public ChunkUnsignedByteArray(int xSize, int ySize, int zSize) {
         this.xSize = xSize;
         this.ySize = ySize;
         this.zSize = zSize;
         data = new byte[xSize * ySize * zSize];
     }
 
-    public ChunkUnsignedByteArray(int xSize, int ySize, int zSize, byte[] data)
-    {
+    public ChunkUnsignedByteArray(int xSize, int ySize, int zSize, byte[] data) {
         this.xSize = xSize;
         this.ySize = ySize;
         this.zSize = zSize;
-        if (data.length == (xSize * ySize * zSize))
-        {
+        if (data.length == (xSize * ySize * zSize)) {
             this.data = data;
-        }
-        else
-        {
+        } else {
             this.data = null;
         }
     }
 
-    @Override
-    public @NotNull Integer get(int x, int y, int z)
-    {
+//    @Override
+    public /*@NotNull Integer*/ int get(int x, int y, int z) {
         int index = (y * zSize * xSize) + (z * xSize) + x;
         return Byte.toUnsignedInt(data[index]);
     }
 
-    @Override
-    public void set(int x, int y, int z, Integer value)
-    {
+//    @Override
+    public void set(int x, int y, int z, /*@NotNull Integer*/ int value) {
         int index = (y * zSize * xSize) + (z * xSize) + x;
-        data[index] = value.byteValue();
+        data[index] = (byte) value;
     }
 
-    @Override
-    public boolean isValid()
-    {
+//    @Override
+    public boolean isValid() {
         return data != null && data.length == xSize * ySize * zSize;
     }
 }
